<!-- Contentful.vue -->
<template>
  <div>
    <!-- define a named slot `render` and pass items into it -->
    <slot name="render" :items="items"></slot>
  </div>
</template>

<script>
import client from '~/plugins/contentful'

export default {
  props: {
    // make the `query` object required
    // no query no call ;)
    query: {
      type: Object,
      required: true
    }
  },

  data() {
    // set default data
    return {
      items: [],
      error: null
    }
  },

  beforeMount() {
    // make the API call using the passed in query
    // and set it to the object
    // -> it will be passed to the `render` slot
    client
      .getEntries(this.query)
      .then(({ items }) => {
        this.items = items
      })
      .catch(error => (this.error = error))
  }
}
</script>
